<template>
  <v-app>
    <v-app-bar
      app
      dense
      color="primary"
      dark
      v-if="isLoggedIn"
    >

      <v-app-bar-nav-icon @click.stop="drawer = !drawer"></v-app-bar-nav-icon>

      <v-toolbar-title>SAC-24</v-toolbar-title>
    </v-app-bar>

    <v-app-bar
        app
        color="primary"
        dark
        v-else
    />

    <v-main>
      <router-view></router-view>
    </v-main>
    <v-navigation-drawer app
      v-model="drawer"
      fixed
      v-if="isLoggedIn"
    >
      <v-subheader>PROFILE USER</v-subheader>
      <v-divider></v-divider>
      <v-list-item :to="`/profile/user/${$store.getters.getUsername}`" class="center">
        <v-list-item-content>
          <v-list-item-subtitle v-text="fullname" />
          <v-list-item-title v-text="username" />
        </v-list-item-content>
      </v-list-item>

      <v-subheader>MAIN MENU</v-subheader>
      <v-divider></v-divider>
      <div v-for="(item, i) in items" :key ="i">
        <v-list dense v-if="!item.child">
          <v-list-item
            :key="item.title"
            link
            :to="item.link"
          >
            <v-list-item-icon>
              <v-icon>{{ item.icon }}</v-icon>
            </v-list-item-icon>

            <v-list-item-content>
              <v-list-item-title>{{ item.title }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>

        <v-list-group v-else
          :value="true"
          :prepend-icon="item.icon"
        >
          <template v-slot:activator>
            <v-list-item-title>{{ item.title }}</v-list-item-title>
          </template>

          <v-list-item
            v-for="(submenu, j) in item.child"
            :key="j"
            link
            :to="submenu.link"
          >
          <v-list-item-content>
            <v-list-item-title v-text="submenu.title"></v-list-item-title>
          </v-list-item-content>
            <v-list-item-icon>
              <v-icon v-text="submenu.icon"></v-icon>
            </v-list-item-icon>
          </v-list-item>
        </v-list-group>
      </div>

      <template v-slot:append>
        <div class="pa-2">
          <v-text-field label="version" :value="version" readonly/>
          <v-btn block color="primary" @click="doLogout">
            Logout
          </v-btn>
        </div>
      </template>
    </v-navigation-drawer>
    <DlgMsgApp ref="dlgMsgApp"/>
    <LoadingApp ref="loadingApp" :dlg-loading="statusProgress" />
  </v-app>
</template>

<script>
import DlgMsg from "./components/dialog/DlgMsg";
import Loading from "./components/dialog/Loading";

export default {
  name: 'App',
  components: {
    DlgMsgApp: DlgMsg,
    LoadingApp: Loading

  },
  data: () => ({
    isLoggedIn: false,
    fullname: null,
    username: null,
    drawer: true,
    items: [
      { title: 'Inventory', icon: 'mdi-view-dashboard',
        child: [
          {title: 'Regional', icon: 'mdi-view-dashboard', link: '/data/regional'},
          {title: 'Witel', icon: 'mdi-view-dashboard', link: '/data/witel'},
          {title: 'STO', icon: 'mdi-view-dashboard', link: '/data/sto'},
          {title: 'GPON', icon: 'mdi-view-dashboard', link: '/data/gpon'},
          {title: 'NMS', icon: 'mdi-view-dashboard', link: '/data/nms'},
        ]
       },
      { title: 'Management', icon: 'mdi-forum', link: '/data/nms',
        child: [
          {title: 'User', icon: 'mdi-forum', link: '/data/nms'},
          {title: 'User Active', icon: 'mdi-forum', link: '/data/nms'},
          {title: 'Permission', icon: 'mdi-forum', link: '/data/nms'},
          {title: 'Role', icon: 'mdi-forum', link: '/data/nms'},
          {title: 'Oauth', icon: 'mdi-forum', link: '/data/nms'},
          {title: 'Detail', icon: 'mdi-forum', link: '/data/nms'},
        ]
      },
      {title:'Config', icon:'mdi-forum', link:'/#',
        child: [
          {title: 'Check', icon:'mdi-forum', link:'/#'},
          {title: 'Create', icon:'mdi-forum', link:'/#'}
        ]
      }
    ],
    version: process.env.VUE_APP_VERSION,
    statusProgress: false,
  }),
  methods: {
    async doRefresh() {
      this.isLoggedIn = this.$store.getters.isLoggedIn
      if (this.isLoggedIn) {
        this.items = []
        this.fullname = this.$store.getters.getFullname
        this.username = this.$store.getters.getUsername
        for (let i in this.$store.getters.getMenus) {
          let parent = this.$store.getters.getMenus[i]
          if (parent.parent_id == null && parent.path !== '/profile/user') {
            let data_parent = {
              title: parent.name,
              icon: 'mdi-view-dashboard',
              seq: parent.seq,
            }
            let menu_child = []
            for (let j in this.$store.getters.getMenus) {
              let child = this.$store.getters.getMenus[j]
              if (child.parent_id === parent.id) {
                let data_child = {
                  title: child.name,
                  icon: 'mdi-forum',
                  link: child.path,
                  seq: child.seq,
                }
                menu_child.push(data_child)
                menu_child.sort(this.sortOrder("seq"))
              }
            }
            data_parent.child = menu_child
            this.items.push(data_parent)
            this.items.sort(this.sortOrder("seq"))
          }
        }
      }
    },
    sortOrder(prop) {
      return function(a, b) {
        if (a[prop] > b[prop]) {
          return 1;
        } else if (a[prop] < b[prop]) {
          return -1;
        }
        return 0;
      }
    },
    async doLogout() {
      if (await this.$refs.dlgMsgApp.confirm('Apakah Ingin Logout?')) {
        this.statusProgress = true
        await this.$store.dispatch('logout')
      }
    }
  },
  created() {
    if (typeof window !== undefined && window._VMA === undefined) {
      window._VMA = this
    }

    this.$on('REFRESH_APP', () => {
      this.doRefresh()
    })
    this.$on('REFRESH_TOKEN', async () => {
      await this.$store.dispatch('refreshToken')
      this.doRefresh()
    })
    this.$on('DASHBORAD', async () => {
      this.doRefresh()
      await this.$router.push('/dashboard')
    })
    this.$on('LOGIN', async () => {
      await window._VMA.$emit('REFRESH_APP')
      await this.$router.push('/login')
    })
  },
  mounted() {
    document.title = 'SAC-24'
    this.doRefresh()
  }
};
</script>
